// Win32DlgOpenCV.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Win32DlgOpenCV.h"

#include <opencv\cv.h>
#include <opencv\highgui.h>

#include <opencv2\core\core.hpp>
#include <opencv2\highgui\highgui.hpp>

//t@C֘A
//iR[h̓}`oCgɐݒ肵j
TCHAR szOpenFileName[MAX_PATH];
TCHAR szSaveFileName[MAX_PATH];

int openFileNameBox(HWND);      //GetOpenFileName֐p
int saveFileNameBox(HWND);      //GetSaveFileName֐p

//͉摜Ao͉摜
cv::Mat imgMatRead; //ǂݍݗp
cv::Mat imgMatWrite; //ݗpiۑۂ͂ɑΏۉ摜ݒ肷邱Ɓj

//WIN32 BMP֘A
HWND hwPic = NULL;
HDC hDC = NULL;
HDC hDCPic = NULL;

IplImage *imgFromOpenCV = NULL;
IplImage img;

BITMAPINFO bmpInfo;
unsigned long* bmpData = NULL;
void iplTobmp(const IplImage*, BITMAPINFO&, unsigned long*);

//Xbh֘A
unsigned int __stdcall CameraCaptureThread(PVOID pv);
HANDLE threadHandle = NULL;
BOOL endFlag = FALSE;

//ȉ̊e֐ɂ肽OpenCV̏Ă
//摜ۑꍇ͕ϐ imgMatWrite ɕۑΏۉ摜ݒ肷
//Ƃ͕ۑ{^ŕۑo

/*------------------------------------------------
 1
-------------------------------------------------*/
void func1(HWND hWnd)
{
	//Xbh`FbN
	if (threadHandle == NULL)
	{
		MessageBox(hWnd, "J͂ł", "G[", MB_OK);
		return;
	}

	cv::Mat img1 = imgMatRead;
	imgMatWrite = img1;

	cv::imshow("cap1", img1);
}

/*------------------------------------------------
2
-------------------------------------------------*/
void func2(HWND hWnd)
{
	//Xbh`FbN
	if (threadHandle == NULL)
	{
		MessageBox(hWnd, "J͂ł", "G[", MB_OK);
		return;
	}

	//Lv`摜O[XP[Xɕϊĕ\
	cv::Mat grImg;
	cv::cvtColor(imgMatRead, grImg, CV_BGR2GRAY);
	cv::imshow("gray", grImg);

	//ۑp̉摜ɐݒ肷
	imgMatWrite = grImg;
}

/*------------------------------------------------
3
-------------------------------------------------*/
void func3(HWND hWnd)
{
	MessageBox(hWnd, "func3", "debug", MB_OK);
}

/*------------------------------------------------
4
-------------------------------------------------*/
void func4(HWND hWnd)
{
	MessageBox(hWnd, "func4", "debug", MB_OK);
}

/*------------------------------------------------
5
-------------------------------------------------*/
void func5(HWND hWnd)
{
	MessageBox(hWnd, "func5", "debug", MB_OK);
}

/*------------------------------------------------
 JLv`[
-------------------------------------------------*/
unsigned int __stdcall CameraCaptureThread(PVOID pv)  {

	cv::VideoCapture cap(0);
	if (!cap.isOpened()){
		return -1;
	}

	while (1){

		if (endFlag){
			break;
		}

		cap >> imgMatRead;

		img = imgMatRead;
		imgFromOpenCV = &img;

		//m
		if (bmpData != NULL){
			HeapFree(GetProcessHeap(), 0, bmpData);
		}

		bmpData = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, imgFromOpenCV->width * imgFromOpenCV->height * 4);

		//iplImageDIB֕ϊ
		iplTobmp(imgFromOpenCV, bmpInfo, bmpData);

		//ŕ`
		StretchDIBits(hDC,
			0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
			0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
			bmpData, &bmpInfo, DIB_RGB_COLORS, SRCCOPY);
	}

	return 0;
}

/*------------------------------------------------
 I
-------------------------------------------------*/
void terminateProc()
{
	//JI
	endFlag = TRUE;
	WaitForSingleObject(threadHandle, INFINITE);
	CloseHandle(threadHandle);

	//OpenCVWindowsN[Y
	cv::destroyAllWindows();

	//摜̗̈̉
	if (imgFromOpenCV != NULL){
		HeapFree(GetProcessHeap(), 0, bmpData); //ꉞ
	}
}

/*----------------------------------------------
 _CAOvV[W
-----------------------------------------------*/
LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ret;
	DWORD dwThread;

	int id = LOWORD(wParam);
	switch (message)
	{
	case WM_INITDIALOG:                // _CAȌ

		hwPic = GetDlgItem(hDlg, IDC_PICTURE);
		hDC = GetDC(hwPic);

		return TRUE;

	case WM_PAINT:

		break;

	case WM_COMMAND:
		switch (id)
		{
		case ID_READ:

			//JLv`[Jn
			if (threadHandle != NULL)
			{
				break;
			}
		
			//XbhN
			threadHandle = (HANDLE)_beginthreadex(
				NULL,          
				0,               
				CameraCaptureThread,  
				NULL,
				0,               
				(unsigned int*)&dwThread);

			if (!threadHandle) {
				MessageBox(hDlg, "XbhNG[", "debug", MB_OK);
			}

			break;

		case ID_SAVE:

			//摜`FbN
			if (imgMatWrite.rows == 0){
				MessageBox(hDlg, "ۑ摜ł", "G[", MB_OK);
				return FALSE;
			}

			//摜ۑ
			ret = saveFileNameBox(hDlg);

			if (ret == 0){
				cv::imwrite((const std::string&)szSaveFileName,imgMatWrite);
			}

			break;

		case IDC_MYICON:                    // ~{^̏
			EndDialog(hDlg, IDOK);
			terminateProc();

			return TRUE;

		case ID_CLOSE:                   // {^̏
			EndDialog(hDlg, IDCANCEL);
			terminateProc();

			return TRUE;

		case ID_EXEC1:
			func1(hDlg);
			break;

		case ID_EXEC2:
			func2(hDlg);
			break;

		case ID_EXEC3:
			func3(hDlg);
			break;

		case ID_EXEC4:
			func4(hDlg);
			break;

		case ID_EXEC5:
			func5(hDlg);
			break;

		default:
			break;
		}
		break;
	}
	return FALSE;
}

//---------------------------------------------------------------
//IplImage BMP(DIB)֕ϊ
//(͂3`lJ[摜ƂOAȊO͓ǂ߂Ȃ)
//---------------------------------------------------------------
void iplTobmp(const IplImage* srcIplImage, BITMAPINFO& bmpInfo, unsigned long* bmpData)
{
	int width = srcIplImage->width;
	int height = srcIplImage->height;

	ZeroMemory(&bmpInfo, sizeof(bmpInfo));
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = width;
	bmpInfo.bmiHeader.biHeight = height;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biCompression = BI_RGB;

	unsigned long pixel;
	unsigned char r, g, b;
	for (int i = 0; i < height; i++){
		for (int j = 0; j < width; j++){
			b = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3];
			g = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 1];
			r = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 2];
			pixel = 0x00000000;
			pixel = (r << 16) + (g << 8) + b;
			bmpData[j + (height - i - 1) * width] = pixel;
		}
	}
}

/*-----------------------------------
	I[vt@C擾
-------------------------------------*/
int openFileNameBox(HWND hWnd)
{
	int i;
	OPENFILENAME ofn;
	
	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szOpenFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szOpenFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szOpenFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szOpenFileName);        //t@C̃TCY
	
	//t@Ĉݓ͋ | ǂݎ`FbN{bNX\Ȃ
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = TEXT("*");                    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̓Ǎ");      //^Cgo[ɕ\镶
	
	i = GetOpenFileName(&ofn);
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}
	
	///MessageBox(hWnd, szOpenFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------
	ۑt@C擾
-------------------------------------*/
int saveFileNameBox(HWND hWnd)
{
	int i;
	OPENFILENAME ofn;
	
	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szSaveFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szSaveFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szSaveFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szSaveFileName);        //t@C̃TCY
	ofn.Flags = OFN_OVERWRITEPROMPT;        // ㏑mF_CAO̕\
	ofn.lpstrDefExt = TEXT("*");    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̕ۑ");        //^Cgo[ɕ\镶
	
	i = GetSaveFileName(&ofn);        //t@Ctĕۑ_CAO{bNX
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}

	////MessageBox(hWnd, szSaveFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------------------------
	C֐
-------------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN_DIALOG), NULL, (DLGPROC)DlgProc);
	return 0;
}

